/* file about.c */
/*
 *      narcisse81 - a graphical frontend for diogene87 
 *	Copyright (C) 2005 - Dominique Parisot
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA
 *
 */


#include <gtk/gtk.h>
#include <assert.h>
#include "global.h"
#include "icon.h"

/*****************************************************************************/
void nc81_about_show()
{
	GtkWidget* dialog;
	GtkWidget* widget;
	GtkWidget* hbox;
	gchar* str;

	dialog = gtk_dialog_new();
	gtk_window_set_modal(GTK_WINDOW(dialog), TRUE);
	gtk_container_set_border_width(GTK_CONTAINER(dialog), 5);
	gtk_window_set_title(GTK_WINDOW(dialog), "About Narcisse81");
	gtk_signal_connect(GTK_OBJECT(dialog),
			"delete_event",
			GTK_SIGNAL_FUNC(gtk_widget_destroy),
			NULL);

	/* icon, name, version*/
	hbox = gtk_hbox_new(FALSE, 5);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), 
			hbox, TRUE, TRUE, 1);
	widget = gtk_pixmap_new(
			nc81_icon_pixmap_array[nc81_icon_diogene87], 
			nc81_icon_bitmap_array[nc81_icon_diogene87]);
	gtk_box_pack_start(GTK_BOX(hbox), widget, TRUE, FALSE, 5);
	str = g_strdup_printf("%s - %s", "Narcisse81", VERSION);
	widget = gtk_label_new(str);
	g_free(str);
	gtk_box_pack_start(GTK_BOX(hbox), widget, TRUE, TRUE, 5);
	gtk_label_set_justify(GTK_LABEL(widget), GTK_JUSTIFY_CENTER);

	widget = gtk_hseparator_new(); 
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), 
			widget, TRUE, TRUE, 1);
	/* description */
	widget = gtk_label_new("Narcisse81 is a graphical frontend \n"\
			"for Diogene87. It was written by \n"\
			"Dominique Parisot and is distributed \n"
			"under GNU GPL version 2.");
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), 
			widget, TRUE, TRUE, 5);
	gtk_label_set_justify(GTK_LABEL(widget), GTK_JUSTIFY_CENTER);

	/* close button */
	widget = gtk_button_new_with_label("Close");
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->action_area), 
			widget, FALSE, FALSE, 1);
	gtk_signal_connect_object(GTK_OBJECT(widget),
			"clicked",
			GTK_SIGNAL_FUNC(gtk_widget_destroy),
			GTK_OBJECT(dialog));

	gtk_widget_show_all(dialog);
}
/*****************************************************************************/
