/* file ref_rule_edit.c */
/*
 *      narcisse81 - a graphical frontend for diogene87 
 *	Copyright (C) 2005 - Dominique Parisot
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA
 *
 */


#include <assert.h>
#include <string.h>
#include <gtk/gtk.h>
#include "global.h"
#include "command.h"

static GtkWidget *field_name;

/****************************************************************************/
static void field_name_valid_callback(gchar** fields, void* data)
{
}
/****************************************************************************/
static gint button_ok_clicked(GtkWidget *widget, gpointer data)
{
	gchar* rule_name;
	gboolean changed;

	/* referential name */
	rule_name = gtk_entry_get_text(GTK_ENTRY(field_name));
	if (nc81_rule_name == NULL)
	{
		/* create a new rule */
		nc81_command_send( "rra \"%r\" \"%x\"",  
			field_name_valid_callback,
			NULL, rule_name, NULL,NULL);
		nc81_rule_select(rule_name);
	}
	else
	{
		changed = GPOINTER_TO_UINT(gtk_object_get_user_data(
					GTK_OBJECT(field_name)));
		if (changed == TRUE)
		{
			/* change the name of the rule */
			nc81_command_send("rrsn \"%r\" \"%R\" \"%x\"", 
				field_name_valid_callback,
				NULL, rule_name, NULL,NULL);
			nc81_rule_select(rule_name);
		}
	}

	/* TODO do not close if error */
	nc81_main_load(nc81_form_referential_rule_view);
	return 0;
}

/****************************************************************************/
static gint button_cancel_clicked(GtkWidget *widget, gpointer data)
{
	nc81_main_load(nc81_form_referential_rule_view);
	return 0;
}
/****************************************************************************/
static void nc81_field_changed_callback(GtkWidget *field, gpointer data)
{
	/* memorize that the field value was changed */
	gtk_object_set_user_data(GTK_OBJECT(field), GUINT_TO_POINTER(TRUE));
}
/****************************************************************************/
/* this function creates a widget which edit or add a referential rule */
GtkWidget* nc81_ref_rule_edit_new(void)
{
	GtkWidget *hbox;
	GtkWidget *widget;
	GtkWidget *container;

	container = gtk_vbox_new(FALSE, 2);

	/* rule name field */
	/*
	hbox = gtk_hbox_new(FALSE, 2);
	gtk_box_pack_start(GTK_BOX(container), hbox, FALSE, FALSE, 1);
	widget = gtk_label_new((nc81_rule_name==NULL)?
			"New rule": "Rule");
	gtk_box_pack_start(GTK_BOX(hbox), widget, FALSE, FALSE, 1);
	widget = gtk_entry_new();
	gtk_box_pack_start(GTK_BOX(hbox), widget, TRUE, TRUE, 10);
	gtk_object_set_user_data(GTK_OBJECT(widget), GUINT_TO_POINTER(FALSE));
	gtk_widget_grab_focus(widget);
	if (nc81_rule_name != NULL)
		gtk_entry_set_text(GTK_ENTRY(widget), nc81_rule_name);
	field_name = widget;
	*/
	field_name = gtk_entry_new();
	gtk_object_set_user_data(GTK_OBJECT(field_name), 
			GUINT_TO_POINTER(FALSE));
	nc81_field_new_pack(
			(nc81_rule_name==NULL)? "New rule": "Rule",
			field_name, GTK_BOX(container));
	if (nc81_rule_name != NULL)
		gtk_entry_set_text(GTK_ENTRY(field_name), nc81_rule_name);

	/* button box */
	hbox = gtk_hbutton_box_new();
	gtk_box_pack_end(GTK_BOX(container), hbox, FALSE, TRUE, 1);
	gtk_button_box_set_layout(GTK_BUTTON_BOX(hbox), GTK_BUTTONBOX_SPREAD);

	/* OK button */
	widget = gtk_button_new_with_label("OK");
	/*
	GTK_WIDGET_SET_FLAGS(widget, GTK_CAN_DEFAULT);
	gtk_widget_grab_default(widget);
	*/
	gtk_signal_connect(GTK_OBJECT(widget), "clicked",
			GTK_SIGNAL_FUNC(button_ok_clicked), NULL);
	gtk_container_add(GTK_CONTAINER(hbox), widget);

	/* Cancel button */
	widget = gtk_button_new_with_label("Cancel");
	gtk_signal_connect(GTK_OBJECT(widget), "clicked",
			GTK_SIGNAL_FUNC(button_cancel_clicked), NULL);
	gtk_container_add(GTK_CONTAINER(hbox), widget);


	/* connect the changed signals */
	gtk_signal_connect(GTK_OBJECT(field_name), "changed",
			GTK_SIGNAL_FUNC(nc81_field_changed_callback), NULL);
	return container;
}
/****************************************************************************/
