/* file global.h */
/*
 *      narcisse81 - a graphical frontend for diogene87 
 *	Copyright (C) 2005 - Dominique Parisot
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA
 *
 */


#ifndef __NC81_GLOBAL__
#define __NC81_GLOBAL__ 1
#include "icon.h"

#define NAME	"Narcisse81"
#define VERSION "0.0.4"

extern gboolean small;
extern gchar* nc81_ref_name;
extern gchar* nc81_task_name;
extern gchar* nc81_job_name;
extern gchar* nc81_day_name;
extern gchar* nc81_target_name;
extern gchar* nc81_queue_name;
extern gchar* nc81_rule_name;
extern gchar* nc81_user_name;
extern gchar* nc81_variable_name;

extern gchar* nc81_config_user;
extern gchar* nc81_config_password;
extern gchar* nc81_config_server;
extern gchar* nc81_config_ip_port;


extern GtkWidget *main_window;

typedef enum _nc81_form_type nc81_form_type;
enum _nc81_form_type
{
	nc81_form_main_menu,

	nc81_form_referential_view,
	nc81_form_referential_edit,
	nc81_form_referential_copy,
	nc81_form_referential_delete,
	nc81_form_referential_plan,

	nc81_form_referential_task_view,
	nc81_form_referential_task_edit,
	nc81_form_referential_task_copy,
	nc81_form_referential_task_delete,
	nc81_form_referential_task_operation,
	nc81_form_referential_task_operation_edit,
	nc81_form_referential_task_operation_simu,

	nc81_form_referential_task_condition_view,
	nc81_form_referential_task_condition_edit,

	nc81_form_referential_task_dep_view,
	nc81_form_referential_task_dep_edit,

	nc81_form_referential_job_view,
	nc81_form_referential_job_edit,
	nc81_form_referential_job_delete,

	nc81_form_referential_job_dep_view,
	nc81_form_referential_job_dep_edit,

	nc81_form_referential_rule_view,
	nc81_form_referential_rule_edit,
	nc81_form_referential_rule_delete,
	nc81_form_referential_rule_operation,
	nc81_form_referential_rule_operation_edit,
	nc81_form_referential_rule_operation_simu,

	nc81_form_exploitation_view,
	nc81_form_exploitation_day_edit,
	nc81_form_exploitation_day_delete,

	nc81_form_exploitation_task_view,
	nc81_form_exploitation_task_edit,
	nc81_form_exploitation_task_dep_view,

	nc81_form_exploitation_task_condition_view,

	nc81_form_exploitation_job_view,
	nc81_form_exploitation_job_edit,
	nc81_form_exploitation_job_dep_view,

	nc81_form_log_day_view,
	nc81_form_log_day_delete,
	nc81_form_log_task_view,
	nc81_form_log_job_view,

	nc81_form_sta_ref_view,
	nc81_form_sta_task_view,
	nc81_form_sta_job_view,

	nc81_form_variable_view,
	nc81_form_variable_edit,
	nc81_form_variable_delete,

	nc81_form_target_view,
	nc81_form_target_edit,
	nc81_form_target_delete,

	nc81_form_queue_view,
	nc81_form_queue_edit,
	nc81_form_queue_delete,

	nc81_form_user_view,
	nc81_form_user_edit,
	nc81_form_user_delete,

	nc81_form_graph_ref_task,
	nc81_form_graph_ref_job,
	nc81_form_graph_exp_task,
	nc81_form_graph_exp_job,

	nc81_form_monitor,
	nc81_form_connection
};

void nc81_main_load(nc81_form_type form_type);
void nc81_main_set_edit_menu(GtkMenu *menu);
void nc81_main_set_select_menu(GtkMenu *menu);

void nc81_set_user(gchar* name);
void nc81_set_password(gchar* name);
void nc81_set_server(gchar* name);
void nc81_set_ip_port(gchar* name);

void nc81_ref_select(gchar* ref_name);
void nc81_day_select(gchar* ref_name);
void nc81_task_select(gchar* task_name);
void nc81_rule_select(gchar* task_name);
void nc81_job_select(gchar* job_name);
void nc81_target_select(gchar* target_name);
void nc81_queue_select(gchar* queue_name);
void nc81_user_select(gchar* user_name);
void nc81_variable_select(gchar* variable_name);

GtkWidget *nc81_button_new_with_icon(gchar* title, nc81_icon_type icon_type);

GtkWidget* nc81_main_menu_new(void);

GtkWidget* nc81_ref_copy_new(void);
GtkWidget* nc81_ref_edit_new(void);
GtkWidget* nc81_ref_view_new(void);
GtkWidget* nc81_ref_dele_new(void);
GtkWidget* nc81_ref_plan_new(void);

GtkWidget* nc81_ref_task_copy_new(void);
GtkWidget* nc81_ref_task_edit_new(void);
GtkWidget* nc81_ref_task_view_new(void);
GtkWidget* nc81_ref_task_dele_new(void);

GtkWidget* nc81_ref_task_dep_view_new(void);
GtkWidget* nc81_ref_task_dep_edit_new(void);

GtkWidget* nc81_ref_task_oper_new(void);
GtkWidget* nc81_ref_task_oper_edit_new(void);
GtkWidget* nc81_ref_task_oper_simu_new(void);

GtkWidget* nc81_ref_task_cond_view_new(void);
GtkWidget* nc81_ref_task_cond_edit_new(void);

GtkWidget* nc81_ref_job_dep_view_new(void);
GtkWidget* nc81_ref_job_dep_edit_new(void);

GtkWidget* nc81_ref_rule_edit_new(void);
GtkWidget* nc81_ref_rule_view_new(void);
GtkWidget* nc81_ref_rule_dele_new(void);

GtkWidget* nc81_ref_rule_oper_new(void);
GtkWidget* nc81_ref_rule_oper_edit_new(void);
GtkWidget* nc81_ref_rule_oper_simu_new(void);

GtkWidget* nc81_ref_job_copy_new(void);
GtkWidget* nc81_ref_job_edit_new(void);
GtkWidget* nc81_ref_job_view_new(void);
GtkWidget* nc81_ref_job_dele_new(void);

GtkWidget* nc81_day_view_new(void);
GtkWidget* nc81_day_edit_new(void);
GtkWidget* nc81_day_dele_new(void);

GtkWidget* nc81_exp_task_cond_view_new(void);

GtkWidget* nc81_exp_task_view_new(void);
GtkWidget* nc81_exp_task_edit_new(void);
GtkWidget* nc81_exp_task_dep_view_new(void);

GtkWidget* nc81_exp_job_view_new(void);
GtkWidget* nc81_exp_job_edit_new(void);
GtkWidget* nc81_exp_job_dep_view_new(void);

GtkWidget* nc81_log_day_view_new(void);
GtkWidget* nc81_log_day_dele_new(void);
GtkWidget* nc81_log_task_view_new(void);
GtkWidget* nc81_log_job_view_new(void);

GtkWidget* nc81_sta_ref_view_new(void);
GtkWidget* nc81_sta_task_view_new(void);
GtkWidget* nc81_sta_job_view_new(void);

GtkWidget* nc81_var_view_new(void);
GtkWidget* nc81_var_edit_new(void);
GtkWidget* nc81_var_dele_new(void);

GtkWidget* nc81_user_view_new(void);
GtkWidget* nc81_user_edit_new(void);
GtkWidget* nc81_user_dele_new(void);

GtkWidget* nc81_target_view_new(void);
GtkWidget* nc81_target_edit_new(void);
GtkWidget* nc81_target_dele_new(void);

GtkWidget* nc81_queue_view_new(void);
GtkWidget* nc81_queue_edit_new(void);
GtkWidget* nc81_queue_dele_new(void);

GtkWidget* nc81_graph_exp_task_new(void);
GtkWidget* nc81_graph_exp_job_new(void);
GtkWidget* nc81_graph_ref_task_new(void);
GtkWidget* nc81_graph_ref_job_new(void);

GtkWidget* nc81_monitor_new(void);
GtkWidget* nc81_connection_new(void);
void nc81_about_show();

GtkWidget* nc81_field_with_icon_new_pack(gchar* label, 
		GtkWidget* widget_to_insert, GtkBox* box, nc81_icon_type icon);

GtkWidget* nc81_field_new_pack(gchar* label, GtkWidget* widget, GtkBox* box);


void nc81_paned_new(GtkWidget* vbox1, GtkWidget* vbox2, GtkWidget* container);


void nc81_message_ok(gchar* msg);

#endif/*__NC81_GLOBAL__*/
